// 6.11.2005   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                                  BrainTrend2.mq4 |
//|                                                www.forex-tsd.com |
//|                                                Nick Bilak        |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "BrainTrading Inc."
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int  CountBars=500;
//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];

bool   river=True;
int    artp,limit,glava,p,Curr;
double spread,Weight,r,r1,Range1,s,val1,val2;
double dartp=7.0,cecf=0.7,Emaxtra,widcha,TR,Values[100],ATR,low,high;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int init()
  {
//---- indicator 0
   SetIndexStyle (0,DRAW_ARROW);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexArrow (0,233);
   SetIndexEmptyValue(1,EMPTY_VALUE);
//---- indicator 1  
   SetIndexStyle (1,DRAW_ARROW);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexArrow (1,234);
   SetIndexEmptyValue(1,EMPTY_VALUE);
//----
   string short_name;
   short_name="BrainTrend2Sig";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"_SELL");
   SetIndexLabel(1,""+short_name+"_BUY" );
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//----
   spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
   
   artp=7;dartp=7.0;s=2;
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start() 
   {
   int Shift,J,counted_bars=IndicatorCounted();
//---- 
   if( CountBars > Bars-3) limit = Bars-3; else limit = CountBars-counted_bars-1;
   if( Close[limit + 2] > Close[limit + 1]) river = True; else river = False;
   Emaxtra = Close[limit + 1];
   glava=0;
   Shift=limit;
//----
   while(Shift>=0)      
   {  
      low=Low [Shift];high=High[Shift];
      TR = spread+ high - low;
      if( MathAbs(spread+ high - Close[Shift + 1]) > TR ) TR = MathAbs(spread+ high - Close[Shift + 1]);
      if( MathAbs(low - Close[Shift + 1]) > TR)  TR = MathAbs(low - Close[Shift + 1]);
      if (Shift == limit) 
      {
         for(J=0;Shift<=artp-1;J++) Values[J] = TR; 
      }   
 		Values[glava] = TR;
      ATR = 0;
      Weight = artp;
      Curr = glava;
      for (J = 0;J<=artp - 1;J++) 
      {
         ATR += Values[Curr] * Weight;
         Weight -= 1.0;
         Curr--;
         if (Curr == -1) Curr = artp - 1;
      }
      ATR = 2.0 * ATR / (dartp * (dartp + 1.0));
      glava++;
      if (glava == artp) glava = 0;
      widcha = cecf * ATR;
      if (river && low < Emaxtra - widcha) 
      {
         river = False;
         Emaxtra = spread+ high;
      }
      if (!river && spread+ high > Emaxtra + widcha) 
      {
         river = True;
         Emaxtra = low;
      }
      if (river && low > Emaxtra) Emaxtra = low;
      if (!river && spread+ high < Emaxtra ) Emaxtra = spread+ high;
      Range1 = iATR(NULL,0,10,Shift);
      val1 = 0;
      val2 = 0;
      if (river) 
        {
         if (p != 1) r1 = low - Range1 * s / 3.0;
         if (p == 1) r1 = -1.0;
         if (r1 > 0) 
         {
            val1 = r1;
            val2 = 0;
         } 
         else 
         {
            val1 = 0;
            val2 = 0;
         }
         Ind_Buffer1[Shift]=val1;
         p = 1;
        } 
      else 
        {
         if (p != 2) r1 = spread+ high + Range1 * s / 3.0;
         if (p == 2) r1 = -1.0;
         if (r1 > 0) 
         {
            val1 = 0;
            val2 = r1;
         } 
         else 
         {
            val1 = 0;
            val2 = 0;
         }
         Ind_Buffer2[Shift]=val2;
         p = 2;
        }
      Shift--;
   }
   
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+